import { create } from 'zustand';

interface ObjectsState {
    selectedCity: number | null;
    selectedYear: number | null;
    currentObjectId: string | null;
}

export const useObjectsStore = create<ObjectsState>(() => ({
    selectedCity: null,
    selectedYear: 2023,
    currentObjectId: null
}));

const getSelectedCity = () => {
    return useObjectsStore.getState().selectedCity
}

const setSelectedCity = (city: number | null) => {
    useObjectsStore.setState(() => ({ selectedCity: city }))
}

const getSelectedYear = () => {
    return useObjectsStore.getState().selectedYear
}

const setSelectedYear = (year: number | null) => {
    useObjectsStore.setState(() => ({ selectedYear: year }))
}

const getCurrentObjectId = () => {
    return useObjectsStore.getState().currentObjectId
}

const setCurrentObjectId = (objectId: string | null) => {
    useObjectsStore.setState(() => ({ currentObjectId: objectId }))
}

export {
    getSelectedCity,
    setSelectedCity,
    getSelectedYear,
    setSelectedYear,
    getCurrentObjectId,
    setCurrentObjectId
}